module(..., package.seeall)

new = function()

	--Import library
	local ui=require("ui_24")
	local loqsprite=require("loq_sprite")

	--Main group declaration
	local localGroup = display.newGroup()
		
		---------------
		--- Global variable
		---------------
		local currentGroup=1
		local globalTransition

		---------------
		--- Components for all pages
		---------------

		--Title
		local txtTitle = display.newText("About Us ...", 40, 80, "Narkisim", 38)
			txtTitle:setTextColor(0)
			--transition.from(txtTitle,{delay=1, time=500, alpha=1, x=-100})

		---------------
		--- About pages
		---------------

		function goDownLittle(obj)
			globalTransition = transition.to( obj, {time=500, y=148, onComplete=goUpLittle} )
		end

		function goUpLittle(obj)
			globalTransition = transition.to( obj, {time=500, y=140, onComplete=goDownLittle} )
		end		

		--About page 1
		local aboutGroup1 = display.newGroup()

			local factory=loqsprite.newFactory("devil-fly")
				local character1=factory:newSpriteGroup("karakter devil")
				character1:setReferencePoint( display.TopLeftReferencePoint )
				character1.x=30
				character1.y=140
				character1.xScale=0.5
				character1.yScale=0.5
				character1.isVisible=false

				local function angelGo()
					character1:prepare("karakter devil")
					character1.isVisible=true
					character1:play()
					transition.from(character1,{time=1000, y=250, onComplete=goDownLittle})
				end
				angelGo()

			--Description text
			local myText = display.newText( "You will start as a demon with a little kindness. And start the journey to stop being evil and become an angel. But time is a life, as fast you try as soon you will become angel.", 130, 120, display.contentWidth-130-20, display.contentHeight * 0.7, "Helvetica", 22 )
				myText:setTextColor(255)			

			aboutGroup1:insert(character1)
			aboutGroup1:insert(myText)


		--About page 2
		local aboutGroup2 = display.newGroup()
			aboutGroup2.x = display.contentWidth --terletak di luar layar bagian kanan
			local bg2=display.newImageRect("image/karikatur_about.png", 580, 587)
				bg2.x=display.contentCenterX
				bg2.y=display.contentCenterY
				bg2.xAlign = "center"
				bg2.yAlign = "center"
				bg2.xScale = 0.5
				bg2.yScale = 0.5
			aboutGroup2:insert(bg2)	

		--About page 3
		local aboutGroup3 = display.newGroup()
			aboutGroup3.x = display.contentWidth --terletak di luar layar bagian kanan
			local bg1=display.newImageRect("image/Primakara_Gradient_Ver.png", 320, 256)
				bg1.x=display.contentCenterX+20
				bg1.y=display.contentCenterY-50
				bg1.xAlign = "center"
				bg1.yAlign = "center"
			aboutGroup3:insert(bg1)	
			
		---------------
		--- Button navigation
		---------------

		--Button home
		local buttonHome=display.newGroup()
			--buttonHome:setReferencePoint( display.BottomRightReferencePoint )
			buttonHome.x=50
			buttonHome.y=50
				local function eventHome()
					director:changeScene({arg=nil},"home", "crossfade")
					--director:changeScene({oldScore=oldScore},"select_karakter","crossfade")
				end
				
				local objButtonHome=ui.newButton({
					defaultSrc="image/exit.png",
					defaultX=95,
					defaultY=95,
					overX=75,
					overY=75,
					embross=true,
					onPress=eventHome
				})
					objButtonHome.xScale=0.5
					objButtonHome.yScale=0.5
				buttonHome:insert(objButtonHome)


		--Button forward
		local btnForward=display.newGroup()
			--btnForward:setReferencePoint( display.BottomRightReferencePoint )
			btnForward.x=display.contentWidth-50
			btnForward.y=50
			--btnForward.isVisible = false

		--Button backward
		local btnBackward=display.newGroup()
			btnBackward:setReferencePoint( display.BottomRightReferencePoint )
			btnBackward.x=display.contentWidth-100
			btnBackward.y=50
			btnBackward.isVisible = false

			--Button forward property
			local function nextPage()
				--director:changeScene({arg=nil},"inGame", "crossfade")
				--director:changeScene({oldScore=oldScore},"select_karakter","crossfade")
				if not globalTransition then
					return false;
				end				
				transition.cancel( globalTransition )
				
				if currentGroup==1 then
					transition.to( aboutGroup1, {delay=1, time=500, x=0-display.contentWidth} )	
					transition.to( aboutGroup2, {delay=1, time=500, x=0} )
					btnForward.isVisible = true
					btnBackward.isVisible = true					
					currentGroup=2
				elseif currentGroup==2 then
					transition.to( aboutGroup2, {delay=1, time=500, x=0-display.contentWidth} )	
					transition.to( aboutGroup3, {delay=1, time=500, x=0} )
					btnForward.isVisible = false
					btnBackward.isVisible = true
					currentGroup=3
				end				
			end
			
			local objButtonNext=ui.newButton({
				defaultSrc="image/btnForward.png",
				defaultX=50,
				defaultY=50,
				overX=50,
				overY=50,
				embross=true,
				onPress=nextPage
			})
			btnForward:insert(objButtonNext)


			--Button backward property
			local function prevPage()
				--director:changeScene({arg=nil},"inGame", "crossfade")
				--director:changeScene({oldScore=oldScore},"select_karakter","crossfade")
				if not globalTransition then
					return false;
				end				
				transition.cancel( globalTransition )			
				
				if currentGroup==3 then
					transition.to( aboutGroup3, {delay=1, time=500, x=display.contentWidth} )	
					transition.to( aboutGroup2, {delay=1, time=500, x=0} )
					btnForward.isVisible = true
					btnBackward.isVisible = true					
					currentGroup=2
				elseif currentGroup==2 then
					transition.to( aboutGroup2, {delay=1, time=500, x=display.contentWidth} )	
					transition.to( aboutGroup1, {delay=1, time=500, x=0} )
					btnForward.isVisible = true
					btnBackward.isVisible = false
					angelGo()
					currentGroup=1
				end				
			end

			local objButtonPrev=ui.newButton({
				defaultSrc="image/btnBackward.png",
				defaultX=50,
				defaultY=50,
				overX=50,
				overY=50,
				embross=true,
				onPress=prevPage
			})
			btnBackward:insert(objButtonPrev)
			
			
			


		--Insert object to localgroup
		--localGroup:insert(bg)	
		localGroup:insert(txtTitle)
		localGroup:insert(aboutGroup1)
		localGroup:insert(aboutGroup2)
		localGroup:insert(aboutGroup3)
		localGroup:insert(btnForward)
		--localGroup:insert(btnBackward)
		localGroup:insert(buttonHome)

	return localGroup
end
