module(..., package.seeall)

new = function ()
	
	--Import library
	local ui=require("ui_24")
	local loqsprite=require("loq_sprite")
	local parallax=require("parallax")
	
	--Code
	local soundClick=audio.loadSound("sound/button.mp3")
	local soundBgHome=audio.loadSound("sound/inGame.wav")
	local localGroup = display.newGroup()
		local homeScene=parallax.newScene({
			width=320,
			height=1500,
			bottom=0,
			left=0,
			repeated="horizontal"
		})							
			local cloud=homeScene:newLayer({
				image="image/cloud-2.png",
				width=1310,
				height=911,
				top=-0,
				left=0,
				repeated="horizontal",
				speed=1
			})
			cloud.xScale=0.5
			cloud.yScale=0.5			
			
			local city=homeScene:newLayer({
				image="image/city-2.png",
				width=612,
				height=897,
				bottom=(display.contentHeight*2)+100,
				left=0,
				repeated="horizontal",
				speed=0.7
			})
			city.xScale=0.5
			city.yScale=0.5			
			
			local bg=homeScene:newLayer({
				image="image/bg_gradien.png",
				width=640,
				height=1280,
				top=-200,
				left=0,
				repeated=false,
				speed=0
			})
			bg.xAlign = "center"
			bg.yAlign = "center"
			bg.xScale=0.5
			bg.yScale=0.5	
		
		local logo=display.newImageRect("image/logo_game.png", 640, 960)
			logo.xAlign = "left"
			logo.yAlign = "top"
			logo.xScale=0.5
			logo.yScale=0.5
			logo.x=display.contentCenterX-10
			logo.y=display.contentCenterY
			transition.from(logo,{delay=250, time=1000, alpha=0.1, x=-100})
			
		local groupButton=display.newGroup()
			groupButton.x=210
			groupButton.y=260
			
			local function play()
				audio.stop()
				audio.play(soundClick)
				director:changeScene({arg=nil},"inGame","crossfade")
				Runtime:removeEventListener("enterFrame",homeLoop)
				Runtime:removeEventListener("enterFrame",timer.performWithDelay(0,devilFront))
			end
			
			local function about()
				audio.stop()
				audio.play(soundClick)
				director:changeScene({arg=nil},"about","crossfade")
				Runtime:removeEventListener("enterFrame",homeLoop)
				Runtime:removeEventListener("enterFrame",timer.performWithDelay(0,devilFront))				
			end
			
			local function exitE()
				audio.play(soundClick)
				os.exit()
			end
			
			local bgButton=display.newImageRect("image/bg_button.png", 412, 440)
				bgButton.xAlign = "center"
				bgButton.yAlign = "center"
				bgButton.xScale=0.5
				bgButton.yScale=0.5
				bgButton.x=0
				bgButton.y=0
			groupButton:insert(bgButton)
			
			local playButton=ui.newButton({
				defaultSrc="image/play_button.png",
				defaultX=279,
				defaultY=100,
				overSrc="image/play_button.png",
				overX=289,
				overY=120,
				embross=true,
				onPress=play
			})			
				playButton.xAlign = "center"
				playButton.yAlign = "center"
				playButton.xScale=0.001
				playButton.yScale=0.0001
				playButton.x=0
				playButton.y=-60
			groupButton:insert(playButton)
			
			local aboutButton=ui.newButton({
				defaultSrc="image/about_button.png",
				defaultX=294,
				defaultY=105,
				overSrc="image/about_button.png",
				overX=304,
				overY=125,
				embross=true,
				onPress=about
			})	
				aboutButton.xAlign = "center"
				aboutButton.yAlign = "center"
				aboutButton.xScale=0.001
				aboutButton.yScale=0.001
				aboutButton.x=0
				aboutButton.y=0
			groupButton:insert(aboutButton)
			
			local exitButton=ui.newButton({
				defaultSrc="image/button_exit.png",
				defaultX=266,
				defaultY=113,
				overSrc="image/button_exit.png",
				overX=276,
				overY=133,
				embross=true,
				onPress=exitE
			})	
				exitButton.xAlign = "center"
				exitButton.yAlign = "center"
				exitButton.xScale=0.001
				exitButton.yScale=0.001
				exitButton.x=0
				exitButton.y=60
			groupButton:insert(exitButton)
						
			transition.from(groupButton,{delay=250, time=1000, alpha=0.1, x=display.contentCenterX+100})	
			transition.to(playButton,{delay=1250, time=500, xScale=0.5, yScale=0.5})	
			transition.to(aboutButton,{delay=1500, time=500, xScale=0.5, yScale=0.5})	
			transition.to(exitButton,{delay=1750, time=500, xScale=0.5, yScale=0.5})	
		
		local factory=loqsprite.newFactory("angel-front", "devil-front")
			local character=factory:newSpriteGroup("malaikat_terbang_depan")
			character.x=display.contentCenterX
			character.y=display.contentCenterY-100			
			character.xScale=0.1
			character.yScale=0.1
			character.isVisible=false
			
			local character1=factory:newSpriteGroup("devil_kedip")			
			character1.xScale=0.8
			character1.yScale=0.8
			character1.isVisible=false			
			
		local function angelZoomOut()
			transition.to(character,{time=1000,x=270, y=60, xScale=0.3,yScale=0.3})
		end
		
		local function devilFrontBack1()
			transition.to(character1,{delay=2000, time=2000, x=-210,y=540, onComplete=devilFront})			
		end		
		local function devilFrontBack2()
			transition.to(character1,{delay=2000, time=2000, y=840, onComplete=devilFront})
		end		
		local function devilFrontBack3()			
			transition.to(character1,{delay=2000, time=2000, x=-360	, onComplete=devilFront})
		end		
		local function devilFront()				
			character1:prepare("devil_kedip")
			character1.isVisible=true
			character1:play()
			 
			local randPosisi=math.random(1,3)
			if randPosisi==1 then
				character1.x=-70
				character1.y=180
				character1.rotation=30
				transition.from(character1,{time=1000, x=-105,y=270, onComplete=devilFrontBack1})
			elseif randPosisi==2 then
				character1.x=-100
				character1.y=340
				character1.rotation=0			
				transition.from(character1,{time=1000, y=420, onComplete=devilFrontBack2})
			elseif randPosisi==3 then
				character1.x=180
				character1.y=100
				character1.rotation=90
				transition.from(character1,{time=1000, x=-180, onComplete=devilFrontBack3})			
			end
		end
		
		local function angelFly()
			character:prepare("malaikat_terbang_depan")
			character.isVisible=true
			character:play()
			transition.to(character,{time=1000, xScale=0.45,yScale=0.45, onComplete=angelZoomOut})
		end
		
		function homeLoop()			
			homeScene:move(5,0)		
		end
		
		--Group for display or layer of object
		localGroup:insert(homeScene)				
		localGroup:insert(logo)
		localGroup:insert(groupButton)
		localGroup:insert(character)
		localGroup:insert(character1)
		
		--Running / Loop			
		audio.play(soundBgHome, {channel=1, loops=-1})	
		Runtime:addEventListener("enterFrame",homeLoop)
		Runtime:addEventListener("enterFrame",timer.performWithDelay(1000,devilFront))
		timer.performWithDelay(0,angelFly)
		
	return localGroup
	
end
