module(..., package.seeall)

new = function ()
	
	--Import library
	local ui=require("ui_24")
	local loqsprite=require("loq_sprite")
	local parallax=require("parallax")	
	local collisions=require("collisions")	
	system.setAccelerometerInterval( 50 )
	
	--Declaration
	local speed=13
	local rotate=0
	local skala=0
	local yCharacter=350
	local maxBoundX
	local minBoundX
	local accelero
	local lastX=0
	local newX=0
	local rotate
	local gameReady=true
	local timerPlayerUpDownMove
	local timerCreateObjects
	local objects={}
	local playerStatusPoint=-90
	local playerScore=0
		
	--Code
	local soundBg=audio.loadSound("sound/bg.mp3")
	local soundClick=audio.loadSound("sound/button.mp3")	
	local localGroup = display.newGroup()	
		local gameScene=parallax.newScene({
			width=320,
			height=1500,
			bottom=0,
			left=0,
			repeated="vertical"
		})	
			local cloud=gameScene:newLayer({
				image="image/cloud.png",
				width=711,
				height=1930,
				bottom=0,
				left=0,
				repeated="vertical",
				speed=0.7
			})
			cloud.xScale=0
			cloud.yScale=0
			
			local yellowBg=gameScene:newLayer({
				image="image/yellowBg.png",
				width=640,
				height=960,
				bottom=0,
				left=0,
				repeated="vertical",
				speed=0.7
			})
			yellowBg.xScale=0.5
			yellowBg.yScale=0.5
			
			local city=gameScene:newLayer({
				image="image/city.png",
				width=688,
				height=952,
				bottom=0,
				left=0,
				repeated="vertical",
				speed=1
			})
			city.xScale=0.5
			city.yScale=0.5
			
			local bg=gameScene:newLayer({
				image="image/bg_gradien.png",
				width=640,
				height=1280,
				top=-200,
				left=0,
				repeated=false,
				speed=0
			})
			bg.xAlign = "center"
			bg.yAlign = "center"
			bg.xScale=0.5
			bg.yScale=0.5
				
		local factory=loqsprite.newFactory("devil-fly", "star")
			local character=factory:newSpriteGroup("karakter devil")
			character.x=display.contentCenterX
			character.y=math.round(display.contentHeight*1.5)
			character.xScale=0.1
			character.yScale=0.1
			character.isVisible=false
		
		--local txtStatusPoint=display.newText("Status point = "..playerStatusPoint, 20, 20, "Helvetica", 18)
			--txtStatusPoint:setTextColor(0)
		--local txtScore=display.newText("Score = "..playerScore, 200, 20, "Helvetica", 18)
			--txtScore:setTextColor(0)
		
		local function characterDown()
			transition.to(character,{time=500, y=yCharacter})
		end
		
		local function characterUp()
			transition.to(character,{time=500, y=yCharacter-10,onComplete=characterDown})
		end
		
		local function onAccelerate( event )			
			accelero = display.contentCenterX + (display.contentWidth * event.xGravity)						
			if accelero > minBoundX and accelero < maxBoundX then				
				character.x=accelero
			end			
		end
		
		
		local scoreBar = display.newGroup()
			local bar=display.newImageRect("image/bar.png", 608, 77)				
				bar.xScale=0.5
				bar.yScale=0.5
				bar.xAlign = "center"
				bar.yAlign = "center"			
				bar.x=display.contentCenterX
				bar.y=display.contentCenterY+260
			local arrowPoint=display.newImageRect("image/panah.png", 34, 48)				
				arrowPoint.xScale=0.5
				arrowPoint.yScale=0.5
				arrowPoint.xAlign = "center"
				arrowPoint.yAlign = "center"			
				--arrowPoint.x=display.contentCenterX+3
				arrowPoint.x=display.contentCenterX+(-90)
				arrowPoint.y=display.contentCenterY+260-15
			scoreBar:insert(bar)
			scoreBar:insert(arrowPoint)
		
		function updateDisplayScore()
			--txtStatusPoint.text="Status point = "..playerStatusPoint
			arrowPoint.x=display.contentCenterX+playerStatusPoint
		end
		
		local updateScore=function()
			score=score+1
			textScore.text="Score: "..score
		end
		
		local startScore=function()
			Runtime:addEventListener("enterFrame",updateScore)
		end
		
		local stopScore=function()
			Runtime:removeEventListener("enterFrame",updateScore)
		end
		
		local function characterReady()
			print("characterReady()")		
			speed=13
			playerStatusPoint=-90
			playerScore=0
			startScore()			
			Runtime:addEventListener ("accelerometer", onAccelerate)
			
			--Timer
			timerPlayerUpDownMove = timer.performWithDelay( 1200, characterUp , 0 )
			timerCreateObjects = timer.performWithDelay( 500, dropObjects , 0 )
		end
		
		function characterStay()			
			rotate=0
			character:timeScale(1)
		end
		
		function characterMoveRight()
			rotate=2
			character:timeScale(2)
		end
		
		function characterMoveLeft()			
			rotate=-2
			character:timeScale(2)
		end
				
		local function devilGo()
			audio.play(soundBg, {channel=1, loops=-1})	
			character:prepare("karakter devil")
			character.isVisible=true
			character:play()
			transition.to(character,{time=1000, y=yCharacter,xScale=0.5,yScale=0.5,onComplete=characterReady})
		end
		
		function tileScheme1(startAtY)
			local objectsTile={}
			local minimumObjDistanceX=100

			local yStart=startAtY
			local numCols=math.random(1,5)
			--print("generate scheme")

			for i=1, numCols do

				local obj
				local xPos
				local yPos=yStart
				local numRows=math.random(1,5)		
				
				--cari xPos yang tidak memungkinkan objek bertumpuk	
				local xPosValid=false			
				local numTrial=0
				while not xPosValid do
					numTrial=numTrial+1

					if numTrial==5 then
						break
					end

					xPosValid=true
					xPos=math.random(10,display.contentWidth-40)
					for j=1,#objectsTile do
						--if collisions.intersectCircles(objects[j].x, objects[j].y, objects[j].width, xPos, yPos, objects[j].width) then
						if math.abs(objectsTile[j].x - xPos) < minimumObjDistanceX then
							xPosValid=false
							break
						end
					end
				end

				if xPosValid then
					--print( "xPos "..xPos )
					for j=1, numRows do
						local a=math.random(1,1) --1 ada, 2 tidak ada
						local b=math.random(1,6) --1 jahat, lainnya baik
						if a==1 then --ada object
							if b==1 then --object jahat
								obj=display.newImageRect("image/swirlstroke_red.png", 30, 30)
								obj.type=2
							else
								obj=display.newImageRect("image/swirlstroke_blue.png", 30, 30)
								obj.type=1
							end

							obj.y=yPos-(j-1)*(obj.height+10)
							obj.x=xPos
							if (playerScore % 500)==0 then
								if speed <= 30 then
									speed=speed+2
								end
							end
							obj.speed=speed
							
							localGroup:insert(obj)
							table.insert(objectsTile, obj)							
						end
					end
				end

			end

			return objectsTile
		end
		
		function dropObjects()		
			local minY=0
			for i=1, #objects do
				if not minY then
					minY=objects[i].y
				elseif objects[i].y < minY then
					minY=objects[i].y
				end
			end
			
			if #objects~=0 and minY < -150 then
				return false
			end

			local objectsNum=#objects
			local newObject=tileScheme1(-200)
			for k,v in pairs(newObject) do objects[k+objectsNum] = v end			
		end
		
		function updateScore()
			playerScore=playerScore+1
			--txtScore.text="Score = "..playerScore
		end
		
		function moveObjects()
			if #objects > 0 then
				local newObjects={} --new objects. object that have y pos > display.contentHeight*1.5 not copied to that table

				--move object
				for i=1, #objects do
					--rotate explode
					if objects[i].scaleEx then
						objects[i]:translate( objects[i].rotateEx, 0 )
						objects[i].xScale = objects[i].xScale + objects[i].scaleEx
						objects[i].yScale = objects[i].yScale + objects[i].scaleEx
					end
					objects[i].y=objects[i].y+objects[i].speed
					if objects[i].y < display.contentHeight*1.5 then
						table.insert(newObjects, objects[i])
						--audio.play(soundExplode)
					else
						objects[i]:removeSelf()
					end
				end
				
				--replace object with new objects
				objects=nil
				objects=newObjects
			end	
		end
		
		function checkCollision()
			for i=1, #objects do
				if objects[i] then
					if collisions.intersectCircles(objects[i].x, objects[i].y, objects[i].width/2, character.x, character.y, 25) then
						--point counting
						if objects[i].type==1 then --terkena objek baik
							if playerStatusPoint<110  then
								playerStatusPoint=playerStatusPoint+1
							end
						elseif objects[i].type==2 then --terkena objek jahat
							if playerStatusPoint>-106 then
								playerStatusPoint=playerStatusPoint-10
							end
						end

						--print("Point1="..playerPoint1..", Point2="..playerPoint2)
						updateDisplayScore()

						--insert explode effect
						local explodeRed=display.newImageRect("image/explosionred02.png", 40, 40)				
						
						explodeRed.x=objects[i].x
						explodeRed.y=objects[i].y
						explodeRed.speed=speed
						explodeRed.type=99 --type ledakan
						explodeRed.rotateEx=0
						explodeRed.scaleEx=0.2
						table.insert( objects, explodeRed )
						
						objects[i]:removeSelf( );
						table.remove( objects, i )
					end
				end
			end
		end
				
		function checkBound()
			maxBoundX=(-gameScene.prop.x+display.contentWidth)-(character.width*0.25)
			minBoundX=-gameScene.prop.x+(character.width*0.25)
			--print(minBoundX.." "..character.x.." "..maxBoundX)
		end
		
		function gameLoop()			
			moveObjects()
			checkCollision()
			gameScene:move(0,5)		
			checkBound()
			if playerStatusPoint<=-110 then
				loseGame()
			elseif playerStatusPoint>=110 then
				winGame()
			end
		end
		
		local loseScreen = display.newGroup()
			local function exitLoseE()			
				audio.stop(1)
				audio.play(soundClick, {channel=2, loops=0})
				timer.cancel(timerPlayerUpDownMove)				
				timer.cancel(timerCreateObjects)
				Runtime:removeEventListener("enterFrame",gameLoop)
				Runtime:removeEventListener ("accelerometer", onAccelerate)
				director:changeScene({arg=nil},"home", "crossfade")
			end
			
			local loseBg=display.newImageRect("image/black_screen_filter.png", 640, 1280)				
				loseBg.xScale=0.5
				loseBg.yScale=0.5
				loseBg.xAlign = "center"
				loseBg.yAlign = "center"			
				loseBg.x=display.contentCenterX
				loseBg.y=display.contentCenterY
			local loseBg1=display.newImageRect("image/bg_button.png", 412, 440)				
				loseBg1.xScale=0.5
				loseBg1.yScale=0.5
				loseBg1.xAlign = "center"
				loseBg1.yAlign = "center"			
				loseBg1.x=display.contentCenterX
				loseBg1.y=display.contentCenterY	
			local loseBg2=display.newImageRect("image/devil_ngeling.png", 292, 255)				
				loseBg2.xScale=0.5
				loseBg2.yScale=0.5
				loseBg2.xAlign = "center"
				loseBg2.yAlign = "center"			
				loseBg2.x=display.contentCenterX
				loseBg2.y=display.contentCenterY
			local loseBg3=ui.newButton({
				defaultSrc="image/exit.png",
				defaultX=95,
				defaultY=95,
				overSrc="image/exit-i.png",
				overX=95,
				overY=95,
				embross=true,
				onPress=exitLoseE
			})
				loseBg3.xScale=0.5
				loseBg3.yScale=0.5
				loseBg3.xAlign = "center"
				loseBg3.yAlign = "center"			
				loseBg3.x=display.contentCenterX+50
				loseBg3.y=display.contentCenterY+60
			loseScreen:insert(loseBg)	
			loseScreen:insert(loseBg1)
			loseScreen:insert(loseBg2)
			loseScreen:insert(loseBg3)
			loseScreen.isVisible=false
		
		local winScreen = display.newGroup()
			local function exitWinE()			
				audio.stop(1)
				audio.play(soundClick, {channel=2, loops=0})
				timer.cancel(timerPlayerUpDownMove)				
				timer.cancel(timerCreateObjects)
				Runtime:removeEventListener("enterFrame",gameLoop)
				Runtime:removeEventListener ("accelerometer", onAccelerate)
				director:changeScene({arg=nil},"home", "crossfade")
			end
			
			local winBg=display.newImageRect("image/black_screen_filter.png", 640, 1280)				
				winBg.xScale=0.5
				winBg.yScale=0.5
				winBg.xAlign = "center"
				winBg.yAlign = "center"			
				winBg.x=display.contentCenterX
				winBg.y=display.contentCenterY
			local winBg1=display.newImageRect("image/bg_button.png", 412, 440)				
				winBg1.xScale=0.5
				winBg1.yScale=0.5
				winBg1.xAlign = "center"
				winBg1.yAlign = "center"			
				winBg1.x=display.contentCenterX
				winBg1.y=display.contentCenterY	
			local winBg2=display.newImageRect("image/winner.png", 356, 250)				
				winBg2.xScale=0.5
				winBg2.yScale=0.5
				winBg2.xAlign = "center"
				winBg2.yAlign = "center"			
				winBg2.x=display.contentCenterX
				winBg2.y=display.contentCenterY
			local winBg3=ui.newButton({
				defaultSrc="image/exit.png",
				defaultX=95,
				defaultY=95,
				overSrc="image/exit-i.png",
				overX=95,
				overY=95,
				embross=true,
				onPress=exitLoseE
			})
				winBg3.xScale=0.5
				winBg3.yScale=0.5
				winBg3.xAlign = "center"
				winBg3.yAlign = "center"			
				winBg3.x=display.contentCenterX+50
				winBg3.y=display.contentCenterY+60
			winScreen:insert(winBg)	
			winScreen:insert(winBg1)
			winScreen:insert(winBg2)
			winScreen:insert(winBg3)
			winScreen.isVisible=false
		
		local pauseScreen = display.newGroup()
			local function resumeE()
				audio.play(soundClick, {channel=2, loops=0})
				localGroup:remove(#localGroup)
				pauseScreen.isVisible=false
				characterStay()
				gameReady=true
				audio.resume(1)
				Runtime:addEventListener("enterFrame",gameLoop)
				Runtime:addEventListener ("accelerometer", onAccelerate)
				character:play()
				startScore()	
			end
			local function exitE()			
				audio.stop(1)
				audio.play(soundClick, {channel=2, loops=0})
				timer.cancel(timerPlayerUpDownMove)				
				timer.cancel(timerCreateObjects)
				Runtime:removeEventListener("enterFrame",gameLoop)
				Runtime:removeEventListener ("accelerometer", onAccelerate)
				director:changeScene({arg=nil},"home", "crossfade")
			end
			
			local pauseBg=display.newImageRect("image/black_screen_filter.png", 640, 1280)				
				pauseBg.xScale=0.5
				pauseBg.yScale=0.5
				pauseBg.xAlign = "center"
				pauseBg.yAlign = "center"			
				pauseBg.x=display.contentCenterX
				pauseBg.y=display.contentCenterY
			local pauseBtnBg=display.newImageRect("image/bg_button.png", 412, 440)				
				pauseBtnBg.xScale=0.5
				pauseBtnBg.yScale=0.5
				pauseBtnBg.xAlign = "center"
				pauseBtnBg.yAlign = "center"			
				pauseBtnBg.x=display.contentCenterX
				pauseBtnBg.y=display.contentCenterY			
			local angel=display.newImageRect("image/face_malaikat.png", 221, 237)				
				angel.xScale=0.5
				angel.yScale=0.5
				angel.xAlign = "center"
				angel.yAlign = "center"			
				angel.x=display.contentCenterX+40
				angel.y=display.contentCenterY-20
			local devil=display.newImageRect("image/face_devil.png", 221, 224)				
				devil.xScale=0.5
				devil.yScale=0.5
				devil.xAlign = "center"
				devil.yAlign = "center"			
				devil.x=display.contentCenterX-30
				devil.y=display.contentCenterY-20
			local playButton=ui.newButton({
				defaultSrc="image/resume.png",
				defaultX=98,
				defaultY=98,
				overSrc="image/resume-i.png",
				overX=98,
				overY=98,
				embross=true,
				onPress=resumeE
			})
				playButton.xScale=0.5
				playButton.yScale=0.5
				playButton.xAlign = "center"
				playButton.yAlign = "center"			
				playButton.x=display.contentCenterX-50
				playButton.y=display.contentCenterY+60
			local muteButton=ui.newButton({
				defaultSrc="image/suara_mute.png",
				defaultX=95,
				defaultY=95,
				overSrc="image/suara_mute-i.png",
				overX=95,
				overY=95,
				embross=true,
				onPress=play
			})			
				muteButton.xScale=0.5
				muteButton.yScale=0.5
				muteButton.xAlign = "center"
				muteButton.yAlign = "center"			
				muteButton.x=display.contentCenterX
				muteButton.y=display.contentCenterY+60			
			local exitButton=ui.newButton({
				defaultSrc="image/exit.png",
				defaultX=95,
				defaultY=95,
				overSrc="image/exit-i.png",
				overX=95,
				overY=95,
				embross=true,
				onPress=exitE
			})						
				exitButton.xScale=0.5
				exitButton.yScale=0.5
				exitButton.xAlign = "center"
				exitButton.yAlign = "center"			
				exitButton.x=display.contentCenterX+50
				exitButton.y=display.contentCenterY+60
			local audioButton=ui.newButton({
				defaultSrc="image/suara.png",
				defaultX=95,
				defaultY=95,
				overSrc="image/suara-i.png",
				overX=95,
				overY=95,
				embross=true,
				onPress=play
			})						
				audioButton.xScale=0.5
				audioButton.yScale=0.5
				audioButton.xAlign = "center"
				audioButton.yAlign = "center"			
				audioButton.x=display.contentCenterX
				audioButton.y=display.contentCenterY+60
			
			audioButton.isVisible=false
			muteButton.isVisible=true
			pauseScreen:insert(pauseBg)
			pauseScreen:insert(pauseBtnBg)			
			pauseScreen:insert(devil)
			pauseScreen:insert(angel)
			pauseScreen:insert(playButton)
			pauseScreen:insert(muteButton)
			pauseScreen:insert(exitButton)
			pauseScreen:insert(audioButton)			
			pauseScreen.isVisible=false
					
		--Group for display or layer of object
		localGroup:insert(gameScene)
		localGroup:insert(character)
		localGroup:insert(scoreBar)		
		
		--Running / Loop			
		Runtime:addEventListener("enterFrame",gameLoop)		
		timer.performWithDelay(500,devilGo)
		
		function loseGame()			
			audio.play(soundClick, {channel=2, loops=0})
			loseScreen.isVisible=true
			gameReady=false
			audio.pause(1)
			Runtime:removeEventListener("enterFrame",gameLoop)
			Runtime:removeEventListener ("accelerometer", onAccelerate)
			character:pause()
			stopScore()	
			localGroup:insert(loseScreen)
		end
		
		function winGame()			
			audio.play(soundClick, {channel=2, loops=0})
			winScreen.isVisible=true
			gameReady=false
			audio.pause(1)
			Runtime:removeEventListener("enterFrame",gameLoop)
			Runtime:removeEventListener ("accelerometer", onAccelerate)
			character:pause()
			stopScore()	
			localGroup:insert(winScreen)
		end
		
		--Pause Game
		function pauseGame()			
			audio.play(soundClick, {channel=2, loops=0})
			pauseScreen.isVisible=true
			gameReady=false
			audio.pause(1)
			Runtime:removeEventListener("enterFrame",gameLoop)
			Runtime:removeEventListener ("accelerometer", onAccelerate)
			character:pause()
			stopScore()	
			localGroup:insert(pauseScreen)
		end
		
		local function pauseEvent()			
			if gameReady then
				pauseGame()			
				--loseGame()
				--winGame()
			end
		end
		
		local pauseButton=ui.newButton({
				defaultSrc="image/pause.png",
				defaultX=107,
				defaultY=107,
				overSrc="image/pause.png",
				overX=87,
				overY=87,
				embross=true,
				onPress=pauseEvent
			})
			pauseButton.xAlign = "center"
			pauseButton.yAlign = "center"
			pauseButton.xScale=0.5
			pauseButton.yScale=0.5
			pauseButton.x=display.contentWidth-(pauseButton.width*0.5)
			pauseButton.y=0
			pauseButton.alpha=0.5
		
	return localGroup
	
end